Generic Image Library: IteratorAdaptorConcept< Iterator > Struct Template Reference

###  | #  |

Public Member Functions | Public Attributes | List of all members
IteratorAdaptorConcept< Iterator > Struct Template Reference
Pixel Iterator » Concepts » IteratorAdaptorConcept

Iterator adaptor is a forward iterator adapting another forward iterator. More...

`#include <pixel_iterator.hpp>`

## Public Member Functions
void | constraints ()

## Public Attributes
Iterator | it

## Detailed Description

template<typename Iterator>
struct boost::gil::IteratorAdaptorConcept< Iterator >

Iterator adaptor is a forward iterator adapting another forward iterator.

In addition to GIL iterator requirements, GIL iterator adaptors must provide the following metafunctions:

- `is_iterator_adaptor<Iterator>`: Returns `std::true_type`
- `iterator_adaptor_get_base<Iterator>`: Returns the base iterator type
- `iterator_adaptor_rebind<Iterator,NewBase>`: Replaces the base iterator with the new one

The adaptee can be obtained from the iterator via the "base()" method.

concept IteratorAdaptorConcept<boost_concepts::ForwardTraversalConcept Iterator>
{
where SameType<is_iterator_adaptor<Iterator>::type, std::true_type>;
typename iterator_adaptor_get_base<Iterator>;
where Metafunction<iterator_adaptor_get_base<Iterator> >;
where boost_concepts::ForwardTraversalConcept<iterator_adaptor_get_base<Iterator>::type>;
typename another_iterator;
typename iterator_adaptor_rebind<Iterator,another_iterator>::type;
where boost_concepts::ForwardTraversalConcept<another_iterator>;
where IteratorAdaptorConcept<iterator_adaptor_rebind<Iterator,another_iterator>::type>;
const iterator_adaptor_get_base<Iterator>::type& Iterator::base() const;
};
boost::gil::IteratorAdaptorConcept
Iterator adaptor is a forward iterator adapting another forward iterator.
Definition concepts/pixel_iterator.hpp:318
boost::gil::Metafunction
Concept for type as metafunction requirement.
Definition basic.hpp:164
boost::gil::SameType
Concept of types equivalence requirement.
Definition basic.hpp:179
boost::gil::is_iterator_adaptor
metafunction predicate determining whether the given iterator is a plain one or an adaptor over anoth...
Definition concepts/pixel_iterator.hpp:40
boost::gil::iterator_adaptor_get_base
returns the base iterator for a given iterator adaptor. Provide an specialization when introducing ne...
Definition concepts/pixel_iterator.hpp:42
boost::gil::iterator_adaptor_rebind
Changes the base iterator of an iterator adaptor. Provide an specialization when introducing new iter...
Definition concepts/pixel_iterator.hpp:41

The documentation for this struct was generated from the following file:

- concepts/pixel_iterator.hpp